unit fDlgMenu;

interface

uses
  Windows,
  Messages,
  Classes,
  Controls,
  Forms,
  StdCtrls,
  ExtCtrls;

type
  TfrmDlgMenu = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
  private
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  end;

var
  frmDlgMenu: TfrmDlgMenu;

implementation

{$R *.dfm}

procedure TfrmDlgMenu.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_RETURN: ModalResult := mrOK;
    VK_ESCAPE: ModalResult := mrCancel;
  end;
end;

procedure TfrmDlgMenu.CMMouseLeave(var Message: TMessage);
begin
  ModalResult := mrCancel;
end;

procedure TfrmDlgMenu.ListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ModalResult := mrOK;
end;

procedure TfrmDlgMenu.ListBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  ListBox1.ItemIndex := Y div ListBox1.ItemHeight;
end;

procedure TfrmDlgMenu.FormActivate(Sender: TObject);
begin
  ListBox1.SetFocus;
  ListBox1.Invalidate;
end;

end.
